// **** BEGIN LICENSE BLOCK ****
//   Copyright(c) 2009 MATSUZAWA Jiro
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA
//   02110-1301, USA.  */
// **** END LICENSE BLOCK ****

var rencon;
if (!rencon) {
    rencon = {};
} else if (typeof rencon != "object") {
    throw new Error("");
}

// CsvOutput
// implement abstract class BIbRecordOutput

rencon.CsvOutput = function()
{
    rencon.BibRecordOutput.call(this);
    this.fileObj = null;
    this.fileName = "";
    this.sep = "\t";
    this.askFileNameFlag = false;
}

rencon.CsvOutput.prototype = new rencon.BibRecordOutput();
rencon.CsvOutput.prototype.constructor = rencon.CsvOutput;
delete rencon.CsvOutput.prototype.funcTable;
delete rencon.CsvOutput.prototype.record;
delete rencon.CsvOutput.prototype.settingsConf;


rencon.CsvOutput.prototype._init = function()
{
    this.fileName = this._getFileName();
    this.sep = this.settingsConf.getSeparator();
    var wkfile = Components.classes["@mozilla.org/file/local;1"].
        createInstance(Components.interfaces.nsILocalFile);
    if (!wkfile) {
        throw new Error("ERROR output file open NG");
    }
    wkfile.initWithPath(this.fileName);

    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
        createInstance(Components.interfaces.nsIFileOutputStream);
    if (!foStream) {
        throw new Error("ERROR output file open NG");
    }
    foStream.init(wkfile, 0x02 | 0x08 | 0x20, 0664, 0);

    var charset = this._getEncoding();
    this.fileObj = Components.classes["\@mozilla.org/intl/converter-output-stream;1"].
        createInstance(Components.interfaces.nsIConverterOutputStream);
    if (!this.fileObj) {
        throw new Error("ERROR output file open NG");
    }
    // a byte which is not supported is converted into "?"
    this.fileObj.init(foStream, charset, 0, "?".charCodeAt(0));
}

rencon.CsvOutput.prototype._terminate = function()
{
    var msgOutput;
    this.fileObj.close();
    if (this.askFileNameFlag == true) {
        return;
    }

    msgOutput = document.getElementById("renconStringBundle").
                    getFormattedString("outputFile", [this.fileName]);
    alert("Rencon: " + msgOutput);
}

rencon.CsvOutput.prototype._putTitle = function(
        order
        )
{
    this._writeValue( this.record.getTitle() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putCreator = function(
        order
        )
{
    this._writeValue( this.record.getCreator() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putJournal = function(
        order
        )
{
    this._writeValue( this.record.getJournal() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putVolume = function(
        order
        )
{
    this._writeValue( this.record.getVolume() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putPages = function(
        order
        )
{
    this._writeValue( this.record.getPages() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putPublisher = function(
        order
        )
{
    this._writeValue( this.record.getPublisher() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putPubDate = function(
        order
        )
{
    this._writeValue( this.record.getPubDate() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._putUrl = function(
        order
        )
{
    this._writeValue( this.record.getUrl() );
    if (order != rencon.BibRecordOutput.LAST_ITEM) {
        this.fileObj.writeString(this.sep);
    }
}

rencon.CsvOutput.prototype._blockPreProc = function()
{
    if (!this._doesPutHeader()) {
        return;
    }
    // output header(line of bibriographic item's name)
    for (var i = 0; i < this.funcTable.length; i++) {
        var f = this.funcTable[i].getFunc();
        if (f === this._putTitle) {
            this._writeValue( this._getTitleHeader() );
        } else if (f === this._putCreator) {
            this._writeValue( this._getCreatorHeader() );
        } else if (f === this._putPubDate) {
            this._writeValue( this._getPubDateHeader() );
        } else if (f === this._putUrl) {
            this._writeValue( this._getUrlHeader() );
        } else if (f === this._putJournal) {
            this._writeValue( this._getJournalHeader() );
        } else if (f === this._putVolume) {
            this._writeValue( this._getVolumeHeader() );
        } else if (f === this._putPages) {
            this._writeValue( this._getPagesHeader() );
        } else if (f === this._putPublisher) {
            this._writeValue( this._getPublisherHeader() );
        } else {
            this._writeValue("");
//            throw new Error("unknown Header");
        }
        if (i < this.funcTable.length - 1) {
            this.fileObj.writeString(this.sep);
        }
    }

    this.fileObj.writeString("\n");
    return;
}

rencon.CsvOutput.prototype._blockPstProc = function()
{
    // no implementation
}


rencon.CsvOutput.prototype.
_loopPreProc    = function()
{
    // no implementation
}


rencon.CsvOutput.prototype.
_loopPstProc    = function()
{
    this.fileObj.writeString("\n");
}


rencon.CsvOutput.prototype.
_getFileName    = function()
{
    var fname;
    var dir;
    var howToSave = this.settingsConf.getHowToSave();
    if (howToSave == "userDir") {
        dir = this.settingsConf.getSaveDir();
        if (!dir) {
            try {
                fname = rencon.FileManager.pickOutFileName();
            } catch (e) {
                this._handleFilePickError(e);
                throw e;
            }
            this.askFileNameFlag = true;
            return fname;
        }

        var file = Components.classes["@mozilla.org/file/local;1"]
                   .createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(dir);
        if (!file.exists()) {
            try {
                fname = rencon.FileManager.pickOutFileName();
            } catch (e) {
                this._handleFilePickError(e);
                throw e;
            }
            this.askFileNameFlag = true;
            return fname;
        }

        fname = rencon.FileManager.genOutFileName();
        return dir + rencon.System.pathDelimiter() + fname;
    } else {
        try {
            fname = rencon.FileManager.pickOutFileName();
        } catch (e) {
            this._handleFilePickError(e);
            throw e;
        }
        this.askFileNameFlag = true;
    }
    return fname;
}

rencon.CsvOutput.prototype.
_getEncoding = function()
{
    return this.settingsConf.getEncoding();
}

rencon.CsvOutput.prototype.
_writeValue = function(
        item
        )
{
    if (typeof item == "string") {
        ;
    } else if (item instanceof String) {
        item = item.toString();
    } else {
        item = "";
    }
    this.fileObj.writeString("\"" + item + "\"");

    return;
}

rencon.CsvOutput.prototype.
_doesPutHeader = function()
{
    return this.settingsConf.getHeader();
}

rencon.CsvOutput.prototype.
_handleFilePickError = function(
        error
        )
{
    var errMsg;
    if (!error.type) {
        return
    }
    switch (error.type) {
    case "dirUnWritable":
        errMsg = document.getElementById("renconStringBundle").
                    getFormattedString("dirIsNotWritable", [error.message]);
        alert("Rencon: " + errMsg);
//         alert("Rencon: 以下のフォルダには保存できません\n" + error.message);
        break;
    case "fileUnWritable":
        errMsg = document.getElementById("renconStringBundle").
                    getFormattedString("fileIsNotReWritable", [error.message]);
        alert("Rencon: " + errMsg);
//         alert("Rencon: 以下のファイルを上書きできません\n" + error.message);
        break;
    }
}
